// App A, pp A27 - A28

#include <iostream.h>

const int DAYS_PER_WEEK = 7;
const int WEEKS_PER_YEAR = 52;

typedef float arrayType[DAYS_PER_WEEK][WEEKS_PER_YEAR];
enum dayType {SUN, MON, TUE, WED, THU, FRI, SAT};

int WeekIndex(int Week)
// Returns column index for a given week.
{
   return (Week-1);
}  // end WeekIndex

// MinTemps is a 2-dimensional array of daily minimum
// temperatures for 52 weeks, where each column of
// the array contains temperatures for one week.

// initially, assume lowest temperature is
// first in the array
LowestTemp = MinTemps[0][0];
DayOfWeek = SUN;
WeekOfYear = 1;

// search array for lowest temperature
for (Week = 1; Week <= WEEKS_PER_YEAR; ++Week)
	for (dayType Day = SUN; Day <= SAT;
									Day = dayType(Day+1))
		if (LowestTemp > MinTemps[Day][WeekIndex(Week)])
		{  LowestTemp = MinTemps[Day][WeekIndex(Week)];
			DayOfWeek = Day;
			WeekOfYear = Week;
		}  // end if, for

// Assertion: LowestTemp is the smallest value in
// MinTemps and occurs on the day and week given by
// DayOfWeek and WeekOfYear, that is, LowestTemp ==
// MinTemps[DayOfWeek][WeekOfYear-1].