// Chap 4, p 165
// Change the name of this file to ListP.h

// *********************************************************
// Header file ListP.h for the ADT list.
// Pointer-based implementation.
// *********************************************************
typedef int listItemType;  // desired-type-of-list-item

struct listNode;  // defined in implementation file
typedef listNode* ptrType;  // pointer to node

#include "boolean.h"

class listClass
{
public:
// constructors and destructor:
   listClass(); 
   listClass(const listClass& L);
   ~listClass();

// list operations:
   boolean ListIsEmpty();
   int ListLength();
   void ListInsert(int NewPosition, listItemType NewItem,
                   boolean& Success);
   void ListDelete(int Position, boolean& Success);
   void ListRetrieve(int Position, listItemType& DataItem, 
                     boolean& Success);

private:
   ptrType PtrTo(int Position);

   int     Size;
   ptrType Head;
}; // end class
// End of header file.
