// Chapter 5, p 217
#include <iostream.h>
#include "boolean.h"

const int BOARD_SIZE = 8;
enum  square {QUEEN, EMPTY};
typedef square boardType[BOARD_SIZE][BOARD_SIZE];

inline int Index(int Number)
// Returns the array index that corresponds to
// a row or column number.
{  return Number - 1;
}  // end Index

boolean Attack(boardType Board, int Row, int Column)
{
// implementation left as an exercise.
}  // end Attack

inline void SetQueen(int Row, int Column, boardType& Board)
// Sets the square on the board in row Row and column Column
// to QUEEN.
{   Board[Index(Row)][Index(Column)] = QUEEN;
}  // end PlaceQueen

inline void RemoveQueen(int Row, int Column, boardType& Board)
// Sets the square on the board in row Row and column Column
// to EMPTY.
{  Board[Index(Row)][Index(Column)] = EMPTY;
}  // end RemoveQueen

void PlaceNextQueen(int Column, boardType& Board,
                    boolean& Done)
// ---------------------------------------------------------
// Places queens in columns Column through BOARD_SIZE of
// Board.
// Precondition: Queens are placed correctly in columns 1 
// through Column-1. BOARD_SIZE is a global constant.
// Postcondition: If a solution is found, each column of
// Board contains one queen and Done is TRUE; otherwise, 
// Done is FALSE (no solution exists for a queen anywhere
// in column Column).
// Calls: Attack, SetQueen, RemoveQueen.
// ---------------------------------------------------------
{
   if (Column > BOARD_SIZE)
      Done = TRUE;    // base case
   else
   {  Done = FALSE;
      int Row = 1;  // square number in column

      while ( (Row <= BOARD_SIZE) && !Done )
      {  // if square can be attacked
         if (Attack(Board, Row, Column))
	    ++Row;  // then consider next square in column
         else       // else place queen and consider next 
         {          // column
            SetQueen(Row, Column, Board);
            PlaceNextQueen(Column+1, Board, Done);

            // if no queen is possible in next column,
            if (!Done)
            {  // backtrack: remove queen placed
               // earlier and try next square in column
               RemoveQueen(Row, Column, Board);
               ++Row;
            }  // end if
	 } // end if
      }  // end while
   }  // end if
}  // end PlaceNextQueen

main()
{  boardType B;
   boolean Done;

   for (I = 1; I <= BOARD_SIZE; ++I)
      for (J = 1; J <= BOARD_SIZE; ++J)
	RemoveQueen(I, J, B);
   PlaceNextQueen(1, B, Done);
   if (Done)

}