// Chap 8, p356

const int MAX_STRING = 15;
typedef const char* stringType;

class ballClass: public sphereClass
{
public:
// constructors and destructor:
   ballClass(double R, stringType N);
   // Creates a ball with radius R and name N.

   ballClass(const ballClass& B);
   // Copies a ball.

   ~ballClass();
   // Deallocates a ball.

// additional or revised operations:
   stringType Name();
   // Returns the name of a ball.

   void SetName(stringType N);
   // Sets (alters) the name of an existing ball.

   void ResetBall(double R, stringType N);
   // Sets (alters) the radius and name of an
   // existing ball to R and N, respectively.

   void DisplayStatistics();
   // Displays the statistics of a ball.

private:
   char TheName[MAX_STRING+1];  // the ball's name
};  // end class
