// Chap 8, pp 365 - 366

#include <string.h>
const double PI = 3.14159;
const MAX_STRING = 15;
typedef char* stringType;

class sphereClass
{
public:
   sphereClass(double R);
   sphereClass();
   sphereClass(const sphereClass& S);
   ~sphereClass();
   double Radius();
   void SetRadius(double R);
   double Diameter();
   double Circumference();
   virtual double Area();
   double Volume();
   virtual void DisplayStatistics();
private:
   double TheRadius;  // the sphere's radius
};  // end class

class ballClass: public sphereClass
{
public:
// constructors and destructor:
   ballClass(double R, stringType N);
   // Creates a ball with radius R and name N.

   ballClass(const ballClass& B);
   // Copy constructor

   ~ballClass();
   // Deallocates a ball.

// additional or revised operations:
   stringType Name();
   // Returns the name of a ball.

   void SetName(stringType N);
   // Sets (alters) the name of an existing ball.

   void ResetBall(double R, stringType N);
   // Sets (alters) the radius and name of an
   // existing ball to R and N, respectively.

   virtual double Area();
   // Cross-sectional area - added to class

private:
   char TheName[MAX_STRING];  // the ball's name
};  // end class
