// Chap 8, pp372 -374

#include <iostream.h>
#include "boolean.h"
typedef int listItemType;  // type oflist item

class baseListClass  // abstract base class
{
public:
   virtual ~baseListClass();  // destructor
   virtual int ListLength() = 0;
   virtual boolean ListIsEmpty() = 0;
   virtual void DisplayList() = 0;
};  // end class

struct listNode;
typedef listNode* ptrType;

class listClass : public baseListClass
{
public:
   // constructors and destructor:
   listClass();
   listClass(const listClass& L);
   virtual ~listClass();

   // list operations:
   virtual int ListLength();

   virtual boolean ListIsEmpty();

   virtual void ListInsert(int NewPosition,
			   listItemType NewItem,
			   boolean& Success);

   virtual void ListDelete(int Position,
			   boolean& Success);

   virtual void ListRetrieve(int Position,
			     listItemType& DataItem,
			     boolean& Success);

   virtual void DisplayList();
   virtual void operator=(const listClass& L);  // added for ex soln

protected:
   void SetSize(int NewSize);       // sets Size
   ptrType ListHead();              // returns Head
   void SetHead(ptrType NewHead);   // sets Head
   listItemType ListItem(ptrType P);// returns a list item
   ptrType ListNext(ptrType P);     // returns list node's Next ptr

private:
   ptrType PtrTo(int Position);

   int     Size;  // number of items on the list
   ptrType Head;  // pointer to the linked list
};  // end class