// Chap 8, pp 376 - 377


sortedListClass::sortedListClass()
{
}  // end constructor

sortedListClass::sortedListClass(const sortedListClass& SL):
      listClass(SL)
{
}  // end copy constructor

sortedListClass::~sortedListClass()
{
}  // end destructor

void sortedListClass::SortedListInsert(listItemType NewItem,
				       boolean& Success)
{
   int NewPosition;

   LocatePosition(NewItem, NewPosition, Success);
   ListInsert(NewPosition, NewItem, Success);
}  // end SortedListInsert

void sortedListClass::SortedListDelete(listItemType Item,
                                       boolean& Success)
{
   int Position;

   LocatePosition(Item, Position, Success);
   ListDelete(Position, Success);
}  // end SortedListDelete

void sortedListClass::LocatePosition(listItemType DataItem,
                                     int& Position,
                                     boolean& Success)
{
   int Len = ListLength();
   Position = 1;
   ptrType Trav = ListHead();
   // Loop invariant: all data items before the one
   // to which Trav points are < DataItem
   while ( (Position < Len) && (ListItem(Trav) < DataItem) )
   {  ++Position;
      Trav = ListNext(Trav);
   }  // end while

   // check whether proper position is after end of list
   if ( (Len > 0) && (ListItem(Trav) < DataItem) )
      ++Position;

   Success = boolean( (Position <= Len) && (DataItem == ListItem(Trav)) );
}  // end LocatePosition

