// Chap 8, pp 381 - 383
// Rename this file as ListT.cpp

// *********************************************************
// Excerpts from the implementation file ListT.cpp.
// *********************************************************
#include "ListT.h"   // header file
#include <stddef.h>  // for NULL

template <class T>
struct listNode
{
   T            Item;
   listNode<T>* Next;
   listNode();  //constructor
};  // end struct

template <class T> 
listNode<T>::listNode(): Next(NULL)
{
}  // end constructor

template <class T> 
listClass<T>::listClass(): Size(0), Head(NULL)
{
}  // end constructor

template <class T>
void listClass<T>::ListInsert(int NewPosition,T NewItem,
			      boolean& Success)
{
   int NewLength = ListLength() + 1;

   Success = boolean((NewPosition >= 1) && (NewPosition <= NewLength));

   if (Success)
   {  Size = NewLength;

      // create new node and place NewItem in it
      listNode<T>* NewPtr = new listNode<T>;

      Success = boolean(NewPtr != NULL);
      if (Success)
      {  NewPtr->Item = NewItem;

	 // attach new node to list
	 if (NewPosition == 1)
	 {  // insert new node at beginning of list
	    NewPtr->Next = Head;
	    Head = NewPtr;
	 }

	 else
	 {  listNode<T>* Prev = PtrTo(NewPosition-1);
	    // insert new node after node
	    // to which Prev points
	    NewPtr->Next = Prev->Next;
	    Prev->Next = NewPtr;
	 }  // end if
      }  // end if
   }  // end if
} // end ListInsert

template <class T>
listNode<T>* listClass<T>::PtrTo(int Position)
{
   if ( (Position < 1) || (Position > ListLength()) )
     return NULL;

   else  // count from the beginning of the list
   {  listNode<T>* Trav = Head;
      for (int Skip = 1; Skip < Position; ++Skip)
	 Trav = Trav->Next;
      return Trav;
   }
}  // end PtrTo
